from sdk32 import *

flipflop_flg = 0

def timer_proc(wnd, msg, wparam, lparam):
    global flipflop_flg
    MessageBeep(0)
    flipflop_flg = not flipflop_flg
    rc = RECT()
    GetClientRect(wnd, rc)
    dc = GetDC(wnd)
    if flipflop_flg:
        brush = CreateSolidBrush(RGB(255,0,0))
    else:
        brush = CreateSolidBrush(RGB(0,0,255))
    FillRect(dc, rc, brush)
    ReleaseDC(wnd, dc)
    DeleteObject(brush)

def wnd_proc(wnd, msg, wparam, lparam):
    if msg == WM_DESTROY:
        KillTimer(wnd, 1)
        PostQuitMessage(0)
        return 0
    return DefWindowProc(wnd, msg, wparam, lparam)

def winmain(inst, prev_inst, cmd_line, cmd_show):
    app_name = 'Beeper2'

    wc = WNDCLASSEX()
    wc.style = CS_HREDRAW | CS_VREDRAW
    wc.wnd_proc = wnd_proc
    wc.inst = inst
    wc.cursor = LoadCursor(0, IDC_ARROW)
    wc.background = GetStockObject(WHITE_BRUSH)
    wc.name = app_name
    RegisterClassEx(wc)

    wnd = CreateWindow(app_name, 'Beeper2 Timer Demo',
                       WS_OVERLAPPEDWINDOW,
                       CW_USEDEFAULT, CW_USEDEFAULT,
                       CW_USEDEFAULT, CW_USEDEFAULT, 0, 0, inst, 0)
    if not SetTimer(wnd, 1, 1000, timer_proc):
        MessageBox(wnd, 'Too many clocks or timers!', app_name,
                   MB_ICONEXCLAMATION | MB_OK)
        return FALSE

    ShowWindow(wnd, cmd_show)
    UpdateWindow(wnd)

    msg = MSG()
    while 1:
        if not GetMessage(msg, 0, 0, 0):
            break
        TranslateMessage(msg)
        DispatchMessage(msg)
    return msg.wparam

if __name__ == '__main__':
    winmain(GetModuleHandle(None), 0, '', SW_SHOWNORMAL)
