typedef struct {
    PyObject_HEAD
    char *buff;
    int len;
    int size;
} Buffer_Obj;

extern PyTypeObject Buffer_Type;

int buffer_ensure_size(Buffer_Obj *self, int size);
PyObject *Buffer();

PyObject *MAKE_DIALOG_TEMPLATE(PyObject *seq);

extern FILE *debug_fp;
void open_debug_log(char *fname, char *mode);
void debug_log(char *fmt, ...);

/* Conversion functions
 */
int proxy_setattr_callable(char *name, PyObject *v, PyObject **obj);
int proxy_setattr_string(char *name, PyObject *v, PyObject **obj, char **str);
PyObject *proxy_getattr(PyObject *obj);

int check_nullcallable(char *name, PyObject *obj);

int conv_nullstr(char *name, PyObject *obj, char **arg);
int conv_intstr(char *name, PyObject *obj, char **arg);
int conv_intnullstr(char *name, PyObject *obj, char **arg);
int conv_nullstruct(char *name, PyTypeObject *type, PyObject *obj, void **arg, int offset);
int conv_dlgtempl(char *name, PyObject *obj, void **arg);

/* Implement a bidirectional set of proxies between windows and Python.
 */
LRESULT CALLBACK dlg_proc_trampoline(HWND wnd, UINT msg, WPARAM wparam, LPARAM lparam);
LRESULT CALLBACK wnd_proc_trampoline(HWND wnd, UINT msg, WPARAM wparam, LPARAM lparam);
LRESULT wnd_proc_call(int wnd_proc, int wnd, int msg, int wparam, int lparam);
PyObject *wnd_proc_setwindowlong(int wnd, int index, PyObject *new_long);
PyObject *wnd_proc_getwindowlong(int wnd, int index);

int name_proc_add(const char *name, PyObject *func);
LONG name_proc_setclasslong(int wnd, int index, int new_long);
LONG name_proc_getclasslong(int wnd, int index);

LRESULT CALLBACK name_proc_trampoline(HWND wnd, UINT msg, WPARAM wparam, LPARAM lparam);

int timerproc_add(HWND wnd, UINT timer_id, PyObject *func);
void timerproc_remove(HWND wnd, UINT timer_id);
void CALLBACK timerproc_trampoline(HWND wnd, UINT msg, UINT event, DWORD time);

/* Build some special structures
 */
typedef struct {
    PyObject_HEAD

    PyObject *h_name;		/* string */
    PyObject *h_aliases;	/* tuple of strings */
    int h_addrtype;
    int h_length;
    PyObject *h_addr_list;	/* tuple of addresses */
} HOSTENT_Obj;

PyObject *hostent_from_buffer(Buffer_Obj *buff);

typedef struct {
    PyObject_HEAD

    PyObject *s_name;		/* string */
    PyObject *s_aliases;	/* tuple of strings */
    short s_port;
    PyObject *s_proto;		/* string */
} SERVENT_Obj;

PyObject *servent_from_buffer(Buffer_Obj *buff);
